nxos_pim_interface – Manages PIM interface configuration — Ansible Documentation

- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# nxos_pim_interface – Manages PIM interface configuration

- Synopsis
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Manages PIM interface configuration settings.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
bfd string added in 2.9 | Choices: enable disable default | Enables BFD for PIM at the interface level. This overrides the bfd variable set at the pim global level. Valid values are 'enable', 'disable' or 'default'. Dependency: 'feature bfd'
border boolean | Choices: no ← yes | Configures interface to be a boundary of a PIM domain.
dr_prio string |  | Configures priority for PIM DR election on interface.
hello_auth_key string |  | Authentication for hellos on this interface.
hello_interval integer |  | Hello interval in milliseconds for this interface.
interface string / required |  | Full name of the interface such as Ethernet1/33.
jp_policy_in string |  | Policy for join-prune messages (inbound).
jp_policy_out string |  | Policy for join-prune messages (outbound).
jp_type_in string | Choices: prefix routemap | Type of policy mapped to `jp_policy_in`.
jp_type_out string | Choices: prefix routemap | Type of policy mapped to `jp_policy_out`.
neighbor_policy string |  | Configures a neighbor policy for filtering adjacencies.
neighbor_type string | Choices: prefix routemap | Type of policy mapped to neighbor_policy.
provider dictionary |  | Deprecated Starting with Ansible 2.5 we recommend using `connection: network_cli`. This option is only required if you are using NX-API. For more information please see the NXOS Platform Options guide. A dict object containing connection details.
| auth_pass string added in 2.5.3 |  | Specifies the password to use if required to enter privileged mode on the remote device. If authorize is false, then this argument does nothing. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_AUTH_PASS` will be used instead.
| authorize boolean added in 2.5.3 | Choices: no ← yes | Instructs the module to enter privileged mode on the remote device before sending any commands. If not specified, the device will attempt to execute all commands in non-privileged mode. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_AUTHORIZE` will be used instead.
| host string / required |  | Specifies the DNS host name or address for connecting to the remote device over the specified transport. The value of host is used as the destination address for the transport.
| password string |  | Specifies the password to use to authenticate the connection to the remote device. This is a common argument used for either cli or nxapi transports. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_PASSWORD` will be used instead.
| port integer | Default: "0 (use common port)" | Specifies the port to use when building the connection to the remote device. This value applies to either cli or nxapi. The port value will default to the appropriate transport common port if none is provided in the task. (cli=22, http=80, https=443).
| ssh_keyfile string |  | Specifies the SSH key to use to authenticate the connection to the remote device. This argument is only used for the cli transport. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_SSH_KEYFILE` will be used instead.
| timeout integer | Default: 10 | Specifies the timeout in seconds for communicating with the network device for either connecting or sending commands. If the timeout is exceeded before the operation is completed, the module will error. NX-API can be slow to return on long-running commands (sh mac, sh bgp, etc).
| transport string / required | Choices: cli ← nxapi | Configures the transport connection to use when connecting to the remote device. The transport argument supports connectivity to the device over cli (ssh) or nxapi.
| use_proxy boolean added in 2.5 | Choices: no yes ← | If `no`, the environment variables `http_proxy` and `https_proxy` will be ignored.
| use_ssl boolean | Choices: no ← yes | Configures the transport to use SSL if set to `yes` only when the `transport=nxapi`, otherwise this value is ignored.
| username string |  | Configures the username to use to authenticate the connection to the remote device. This value is used to authenticate either the CLI login or the nxapi authentication depending on which transport is used. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_USERNAME` will be used instead.
| validate_certs boolean | Choices: no yes ← | If `no`, SSL certificates will not be validated. This should only be used on personally controlled sites using self-signed certificates. If the transport argument is not nxapi, this value is ignored.
sparse boolean | Choices: no ← yes | Enable/disable sparse-mode on the interface.
state string | Choices: present ← default | Manages desired state of the resource.

## Notes

Note

- Tested against NXOSv 7.3.(0)D1(1) on VIRL
- When `state=default`, supported params will be reset to a default state. These include `dr_prio`, `hello_auth_key`, `hello_interval`, `jp_policy_out`, `jp_policy_in`, `jp_type_in`, `jp_type_out`, `border`, `neighbor_policy`, `neighbor_type`.
- The `hello_auth_key` param is not idempotent.
- `hello_auth_key` only supports clear text passwords.
- When `state=absent`, pim interface configuration will be set to defaults and pim-sm will be disabled on the interface.
- PIM must be enabled on the device to use this module.
- This module is for Layer 3 interfaces.
- For information on using CLI and NX-API see the NXOS Platform Options guide
- For more information on using Ansible to manage network devices see the Ansible Network Guide
- For more information on using Ansible to manage Cisco devices see the Cisco integration page.

## Examples

    - name: Ensure PIM is not running on the interface
      nxos_pim_interface:
        interface: eth1/33
        state: absent

    - name: Ensure the interface has pim-sm enabled with the appropriate priority and hello interval
      nxos_pim_interface:
        interface: eth1/33
        dr_prio: 10
        hello_interval: 40
        state: present

    - name: Ensure join-prune policies exist
      nxos_pim_interface:
        interface: eth1/33
        jp_policy_in: JPIN
        jp_policy_out: JPOUT
        jp_type_in: routemap
        jp_type_out: routemap

    - name: disable bfd on the interface
      nxos_pim_interface:
        interface: eth1/33
        bfd: disable

    - name: Ensure defaults are in place
      nxos_pim_interface:
        interface: eth1/33
        state: default

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
commands list | always | command sent to the device Sample: ['interface eth1/33', 'ip pim neighbor-policy test', 'ip pim bfd-instance disable', 'ip pim neighbor-policy test']

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Network Team. [network]

### Red Hat Support

More information about Red Hat’s support of this module is available from this Red Hat Knowledge Base article.

### Authors

- Jason Edelman (@jedelman8)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.